package Hexel;

import java.io.InputStreamReader;
import java.util.Hashtable;
import java.util.Scanner;

import Hexel.util.CharToKeyEvent;

public class Config {

	public Hashtable<String, Integer> controls = new Hashtable<String, Integer>();

	public Config() {
		try {
			// Scanner in = new Scanner(new FileReader("hexel.config"));
			Scanner in = new Scanner(new InputStreamReader(
					Config.class.getResourceAsStream("/hexel.config")));

			while (in.hasNextLine()) {
				String s = in.nextLine();
				String[] parts = s.split("\\s+");
				String control = parts[0];
				String key = parts[1];
				setControl(control, key);
			}
			in.close();
		} catch (Exception e) {
			System.out.println("Caught Exception loading config!");
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void setControl(String control, String key_descriptor) {
		char key;
		if (key_descriptor.equals("SPACE")) {
			key = ' ';
		} else {
			key = key_descriptor.charAt(0);
		}
		this.controls.put(control, CharToKeyEvent.convert(key));
	}

}
