package Hexel.blocks.rules;

import java.sql.NClob;
import java.util.ArrayList;

import Hexel.blocks.BlockDelta;
import Hexel.blocks.BlockRule;
import Hexel.blocks.BlockTools;
import Hexel.blocks.types.Block;
import Hexel.chunk.Chunk;
import Hexel.chunk.Chunks;
import Hexel.math.HexGeometry;
import Hexel.math.Vector2i;
import Hexel.math.Vector3i;

public class HealRule implements BlockRule {

	public static final int STEPS_BETWEEN_UPDATES = 10;
	@Override
	public int stepsUntilConsider(int x, int y, int z, Block b,
			Chunk c, Chunks chunks, int steps, Vector3i tmp, Vector2i tmp2) {
		return (10 - steps % 10) % 10;
	}

	@Override
	public boolean isMatch(int x, int y, int z, Block b, Chunk c,
			Chunks chunks, int steps, Vector3i tmp, Vector2i tmp2) {
		return b.getHealth() < b.getMaxHealth();
	}

	@Override
	public ArrayList<BlockDelta> apply(int x, int y, int z, Block b,
			Chunk c, Chunks chunks, int steps, Vector3i tmp, Vector2i tmp2) {
		ArrayList<BlockDelta> deltas = new ArrayList<BlockDelta>();
		int newHealth = Math.min(b.getHealth()+1, b.getMaxHealth());
		Block newB = BlockTools.updateHealth(b, newHealth);
		HexGeometry.globalToLocal(x, y, z, tmp);
		deltas.add(new BlockDelta(x, y, z, newB, false, c.stepsToSim[tmp.x][tmp.y][tmp.z]));
		return deltas;
	}
}
