package Hexel.blocks.rules;

import java.util.ArrayList;

import Hexel.blocks.BlockDelta;
import Hexel.blocks.BlockRule;
import Hexel.blocks.types.Block;
import Hexel.blocks.types.BlockSeed;
import Hexel.blocks.types.BlockWood;
import Hexel.blocks.types.BlockWoodData;
import Hexel.chunk.Chunk;
import Hexel.chunk.Chunks;
import Hexel.math.HexGeometry;
import Hexel.math.Vector2i;
import Hexel.math.Vector3i;

public class SeedRule implements BlockRule {
	@Override
	public int stepsUntilConsider(int x, int y, int z, Block b,
			Chunk c, Chunks chunks, int steps, Vector3i tmp, Vector2i tmp2) {
		return (1000 - steps % 1000) % 1000;
	}

	@Override
	public boolean isMatch(int x, int y, int z, Block b, Chunk c,
			Chunks chunks, int steps, Vector3i tmp, Vector2i tmp2) {
		return true;
	}

	@Override
	public ArrayList<BlockDelta> apply(int x, int y, int z, Block b,
			Chunk c, Chunks chunks, int steps, Vector3i tmp, Vector2i tmp2) {
		ArrayList<BlockDelta> deltas = new ArrayList<BlockDelta>();
		BlockWood woodBlock = BlockWood.Make(new BlockWoodData(BlockWood.MAX_HEALTH, 0, 0, 0, true));
		HexGeometry.globalToLocal(x, y, z, tmp);
		deltas.add(new BlockDelta(x, y, z, woodBlock, false, c.stepsToSim[tmp.x][tmp.y][tmp.z]));
		return deltas;
	}

}
