package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;

public class BlockDebug extends Block {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1165489078938542775L;

	private static Hashtable<Integer, BlockDebug> blockTable = new Hashtable<Integer, BlockDebug>();
	public static BlockDebug Make(int health){
		if (!blockTable.containsKey(health)){
			blockTable.put(health, new BlockDebug(health));
		}
		return blockTable.get(health);
	}

	public final int health;
	public static final int MAX_HEALTH = 10;

	private BlockDebug(int health) {
		this.health = health;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.health;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(0, 1);
	}

	@Override
	public int getBottomTextureIndex() {
		return TextureAtlas.getTextureIndex(0, 0);
	}

	@Override
	public int getSideTextureIndex() {
		return getBottomTextureIndex();
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Debug";
	}

}
