package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;
import Hexel.util.Pair;

public class BlockDirt extends Block {
	/**
	 * 
	 */
	private static final long serialVersionUID = 258224785155320292L;

	private static Hashtable<Pair<Integer, Boolean>, BlockDirt> blockTable = new Hashtable<Pair<Integer, Boolean>, BlockDirt>();
	public static BlockDirt Make(int health, boolean hasGrass){
		Pair<Integer, Boolean> key = new Pair<Integer, Boolean>(health, hasGrass);
		if (!blockTable.containsKey(key)){
			blockTable.put(key, new BlockDirt(health, hasGrass));
		}
		return blockTable.get(key);
	}

	public final int health;
	public final boolean hasGrass;
	public static final int MAX_HEALTH = 10;

	private BlockDirt(int health, boolean hasGrass) {
		this.health = health;
		this.hasGrass = hasGrass;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.health;
	}

	@Override
	public int getTopTextureIndex() {
		if (hasGrass)
			return TextureAtlas.getTextureIndex(1, 0);
		return TextureAtlas.getTextureIndex(2, 1);
	}

	@Override
	public int getBottomTextureIndex() {
		return TextureAtlas.getTextureIndex(2, 1);
	}

	@Override
	public int getSideTextureIndex() {
		if (hasGrass)
			return TextureAtlas.getTextureIndex(1, 1);
		return TextureAtlas.getTextureIndex(2, 1);
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Dirt";
	}

}
