package Hexel.blocks.types;

import java.util.Hashtable;

public class BlockEmpty extends BlockTransparent {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3511748305760048023L;

	private static Hashtable<Integer, BlockEmpty> blockTable = new Hashtable<Integer, BlockEmpty>();
	public static BlockEmpty Make(int lightLevel){
		if (!blockTable.containsKey(lightLevel)){
			blockTable.put(lightLevel, new BlockEmpty(lightLevel));
		}
		return blockTable.get(lightLevel);
	}

	private BlockEmpty(int lightLevel){
		super(lightLevel, 0);
	}

	@Override
	public int getMaxHealth() {
		return 0;
	}

	@Override
	public int getHealth() {
		return 0;
	}

	@Override
	public int getTopTextureIndex() {
		return 0;
	}

	@Override
	public int getBottomTextureIndex() {
		return 0;
	}

	@Override
	public int getSideTextureIndex() {
		return 0;
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Empty";
	}
}
