package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;
import Hexel.util.Pair;

public class BlockGlass extends BlockTransparent {
	/**
	 * 
	 */
	private static final long serialVersionUID = 2462598086660061951L;

	private static Hashtable<Pair<Integer, Integer>, BlockGlass> blockTable =
			new Hashtable<Pair<Integer, Integer>, BlockGlass>();
	public static BlockGlass Make(int lightLevel, int health){
		Pair<Integer, Integer> key = new Pair<Integer, Integer>(lightLevel, health);
		if (!blockTable.containsKey(key)){
			blockTable.put(key, new BlockGlass(lightLevel, health));
		}
		return blockTable.get(key);
	}

	public final int health;
	public static final int MAX_HEALTH = 10;

	private BlockGlass(int lightLevel, int health) {
		super(lightLevel, 0);
		this.health = health;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.health;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(3, 2);
	}

	@Override
	public int getBottomTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public int getSideTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Glass";
	}
}
