package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;
import Hexel.util.Pair;

public class BlockLeaf extends BlockTransparent {
	/**
	 * 
	 */
	private static final long serialVersionUID = 2079102345207811696L;

	private static Hashtable<Pair<Integer, Integer>, BlockLeaf> blockTable =
			new Hashtable<Pair<Integer, Integer>, BlockLeaf>();
	public static BlockLeaf Make(int lightLevel, int health){
		Pair<Integer, Integer> key = new Pair<Integer, Integer>(lightLevel, health);
		if (!blockTable.containsKey(key)){
			blockTable.put(key, new BlockLeaf(lightLevel, health));
		}
		return blockTable.get(key);
	}

	public final int health;
	public static final int MAX_HEALTH = 10;

	private BlockLeaf(int lightLevel, int health) {
		super(lightLevel, 1);
		this.health = health;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.health;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(1, 2);
	}

	@Override
	public int getBottomTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public int getSideTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Leaves";
	}
}
