package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;
import Hexel.util.Pair;

public class BlockSeed extends Block {

	/**
	 * 
	 */
	private static final long serialVersionUID = -382593129708807801L;

	private static Hashtable<Pair<Integer, Integer>, BlockSeed> blockTable = new Hashtable<Pair<Integer, Integer>, BlockSeed>();
	public static BlockSeed Make(int maxHeight, int health){
		Pair<Integer, Integer> key = new Pair<Integer, Integer>(maxHeight, health);
		if (!blockTable.containsKey(key)){
			blockTable.put(key, new BlockSeed(maxHeight, health));
		}
		return blockTable.get(key);
	}

	public final int maxHeight;
	public final int health;
	public static final int MAX_HEALTH = 10;

	private BlockSeed(int maxHeight, int health) {
		this.maxHeight = maxHeight;
		this.health = health;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.health;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(0, 2);
	}

	@Override
	public int getBottomTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public int getSideTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Seed";
	}
}
