package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;

public class BlockStone extends Block {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6720121110698998292L;

	private static Hashtable<Integer, BlockStone> blockTable = new Hashtable<Integer, BlockStone>();
	public static BlockStone Make(int health){
		if (!blockTable.containsKey(health)){
			blockTable.put(health, new BlockStone(health));
		}
		return blockTable.get(health);
	}

	public final int health;
	public static final int MAX_HEALTH = 50;

	private BlockStone(int health) {
		this.health = health;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.health;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(2, 0);
	}

	@Override
	public int getBottomTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public int getSideTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Stone";
	}
}
