package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.math.Vector3i;
import Hexel.rendering.TextureAtlas;
import Hexel.util.Triple;

public class BlockWater extends BlockTransparent {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7140775785223832827L;

	private static Hashtable<Triple<Integer, Integer, Integer>, BlockWater> blockTable =
			new Hashtable<Triple<Integer, Integer, Integer>, BlockWater>();
	public static BlockWater Make(int lightLevel, int bottom, int top){
		Triple<Integer, Integer, Integer> key = new Triple<Integer, Integer, Integer>(lightLevel, bottom, top);
		if (!blockTable.containsKey(key)){
			blockTable.put(key, new BlockWater(lightLevel, bottom, top));
		}
		return blockTable.get(key);
	}

	private BlockWater(int lightLevel, int bottom, int top) {
		super(lightLevel, 2);
		this.top = top;
		this.bottom = bottom;
	}

	@Override
	public int getMaxHealth() {
		return 0;
	}

	@Override
	public int getHealth() {
		return 0;
	}

	private final int top;
	private final int bottom;

	public static int MAX_VOLUME = 8;
	public Vector3i target;

	public int getTop() {
		return this.top;
	}

	public int getBottom() {
		return this.bottom;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(2, 2);
	}

	@Override
	public int getBottomTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public int getSideTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public double getFracBottom() {
		return this.bottom * 1.0 / MAX_VOLUME;
	}

	@Override
	public double getFracTop() {
		return this.top * 1.0 / MAX_VOLUME;
	}

	@Override
	public String getName() {
		return "Water";
	}
}
