package Hexel.blocks.types;

import java.util.Hashtable;

import Hexel.rendering.TextureAtlas;
import Hexel.util.Triple;

public class BlockWood extends Block {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8473546971358802153L;

	private static Hashtable<BlockWoodData, BlockWood> blockTable =
			new Hashtable<BlockWoodData, BlockWood>();
	public static BlockWood Make(BlockWoodData data){
		if (!blockTable.containsKey(data)){
			blockTable.put(data, new BlockWood(data));
		}
		return blockTable.get(data);
	}

	public static final int MAX_HEALTH = 10;
	
	public final BlockWoodData data;

	private BlockWood(BlockWoodData data) {
		this.data = data;
	}

	@Override
	public int getMaxHealth() {
		return MAX_HEALTH;
	}

	@Override
	public int getHealth() {
		return this.data.health;
	}

	@Override
	public int getTopTextureIndex() {
		return TextureAtlas.getTextureIndex(3, 1);
	}

	@Override
	public int getBottomTextureIndex() {
		return getTopTextureIndex();
	}

	@Override
	public int getSideTextureIndex() {
		return TextureAtlas.getTextureIndex(3, 0);
	}

	@Override
	public double getFracBottom() {
		return 0;
	}

	@Override
	public double getFracTop() {
		return 1;
	}

	@Override
	public String getName() {
		return "Wood";
	}
}
