package Hexel.blocks.types;

public class BlockWoodData {
	public final int health;
	public final int level;
	public final int branchLevel;
	public final int branches;
	public final boolean alive;
	
	public static BlockWoodData deadBlockWoodData = new BlockWoodData(BlockWood.MAX_HEALTH, 0, 0, 0, true);
	
	public BlockWoodData(int health, int level, int branchLevel, int branches, boolean alive){
		this.health = health;
		this.level = level;
		this.branchLevel = branchLevel;
		this.branches = branches;
		this.alive = alive;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (alive ? 1231 : 1237);
		result = prime * result + branchLevel;
		result = prime * result + branches;
		result = prime * result + health;
		result = prime * result + level;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BlockWoodData other = (BlockWoodData) obj;
		if (alive != other.alive)
			return false;
		if (branchLevel != other.branchLevel)
			return false;
		if (branches != other.branches)
			return false;
		if (health != other.health)
			return false;
		if (level != other.level)
			return false;
		return true;
	}

}
