package Hexel.chunk;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import Hexel.Hexel;
import Hexel.math.Vector2i;

public class HighestBlockFile {
	static {
		File out = new File(getFolder());
		if (!out.exists()) {
			out.mkdirs();
		}
	}

	private static final Object lock = new Object();

	public static void save(Vector2i loc, Integer[][] map) {
		if (!Hexel.save)
			return;
		synchronized (lock){
			String path = getPath(loc);
			File file = new File(Hexel.workingDir, path);
			try {
				if (!file.exists() && !file.createNewFile()) {
					System.out.println("Failed to create file!");
				}
				ObjectOutputStream out = new ObjectOutputStream(
						new FileOutputStream(file));
				out.writeObject(map);
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
				System.exit(1);
			}
		}

	}

	public static Integer[][] load(Vector2i loc) {

		synchronized (lock) {
			Integer[][] map = null;
			try {
				String path = getPath(loc);
				FileInputStream fileIn = new FileInputStream(path);
				ObjectInputStream in = new ObjectInputStream(fileIn);
				map = (Integer[][]) in.readObject();
				in.close();
				fileIn.close();
			} catch (IOException e) {
				e.printStackTrace();
				System.exit(1);
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
				System.exit(1);
			}
			return map;
		}
	}

	public static boolean has(Vector2i loc) {
		synchronized (lock) {
			String path = getPath(loc);
			File f = new File(path);
			return f.exists();
		}
	}

	private static String getFolder() {
		return "state/highestBlocks/";
	}

	private static String getFilename(Vector2i loc) {
		return loc + ".ser";
	}

	private static String getPath(Vector2i loc) {
		return getFolder() + getFilename(loc);
	}
}
