package Hexel.generation;

import Hexel.Cleanup;
import Hexel.blocks.types.Block;
import Hexel.chunk.Chunk;
import Hexel.chunk.Chunks;
import Hexel.generation.terrainGenerator.FlatTerrainMap;
import Hexel.generation.terrainGenerator.ForestTerrainMap;
import Hexel.generation.terrainGenerator.TerrainMap;
import Hexel.math.Vector2i;
import Hexel.math.Vector3i;

public class ChunkGenerator {
	private TerrainMap tm;


	//public static GrassBlock gb = new GrassBlock();
	//public static StoneBlock sb = new StoneBlock();
	//public static EmptyBlock eb = new EmptyBlock();
	//public static WoodBlock wb = new WoodBlock();
	//public static SeedBlock seedb = new SeedBlock();

	public ChunkGenerator(Chunks chunks, Cleanup cleanup) {
		int seed = 434;
		this.tm = new ForestTerrainMap(seed);
	}

	public Chunk genChunk(Vector3i pos) {
		return this.genChunk(pos.x, pos.y, pos.z);
	}

	public Chunk genChunk(int cx, int cy, int cz) {
		Chunk chunk = new Chunk(cx, cy, cz);

		Vector2i tmp = new Vector2i();

		for (int x = 0; x < 32; x++) {
			for (int y = 0; y < 16; y++) {
				for (int z = 0; z < 32; z++) {
					int gx = cx * 32 + x;
					int gy = cy * 16 + y;
					int gz = cz * 32 + z;
					Block b = this.tm.getBlock(gx, gy, gz, tmp);
					chunk.set(x, y, z, b);
					chunk.stepsToSim[x][y][z] = 50;

				}
			}
		}

		chunk.stepsToNeedSim = 0;
		chunk.modified = false;

		return chunk;
	}

}
