package Hexel.generation.terrainGenerator;

import java.util.Random;

import Hexel.blocks.types.Block;
import Hexel.blocks.types.BlockDirt;
import Hexel.blocks.types.BlockEmpty;
import Hexel.blocks.types.BlockSeed;
import Hexel.generation.terrainGenerator.heightMaps.FractalHeightMap;
import Hexel.generation.terrainGenerator.heightMaps.HeightMap;
import Hexel.math.Vector2i;
import Hexel.util.Util;

public class ForestTerrainMap implements TerrainMap {
	
	private HeightMap hm;
	
	private int seed;
	
	private Random random = new Random();
	
	public ForestTerrainMap(int seed){
		this.hm = new FractalHeightMap(seed);
		this.seed = seed;
	}

	@Override
	public Block getBlock(int x, int y, int z, Vector2i tmp) {
		
		int height = this.hm.getHeight(x, y);
		
		if (z > height+1){
			return BlockEmpty.Make(0);
		}
		else if (z == height+1){
			int hash = 3;
			hash = 97 * hash + x;
			hash = 97 * hash + y;
			hash = 97 * hash + z;
			if (Util.hashToDouble(hash+this.seed) < .01) {
				return BlockSeed.Make(50, BlockSeed.MAX_HEALTH);
			}
			else {
				return BlockEmpty.Make(0);
			}
		}
		else if (z == height){
			return BlockDirt.Make(BlockDirt.MAX_HEALTH, true);
		}
		else {
			return BlockDirt.Make(BlockDirt.MAX_HEALTH, false);
		}
	}

}
