package Hexel.generation.terrainGenerator.originalPlateGenerator.heightMap;

import Hexel.Cleanup;
import Hexel.chunk.Chunk;
import Hexel.math.HexGeometry;
import Hexel.math.Vector2i;
import Hexel.util.Generator;

public class HexBlockHeightMapGenerator implements
Generator<HexBlockHeightMap, Vector2i> {

	private BlockHeightMaps bhms;

	public HexBlockHeightMapGenerator(Cleanup cleanup) {
		this.bhms = new BlockHeightMaps(cleanup);
	}

	@Override
	public HexBlockHeightMap gen(Vector2i cpos) {
		HexBlockHeightMap hbhm = new HexBlockHeightMap();

		int cx = cpos.x * Chunk.WIDTH;
		int cy = cpos.y * Chunk.HEIGHT;

		Vector2i tmp = new Vector2i();

		int[][] hmap = hbhm.heights;

		Vector2i hex = new Vector2i();
		Vector2i tri = new Vector2i();

		for (int y = 0; y < 16; y++) {
			for (int x = 0; x < 32; x++) {
				HexGeometry.tringleToHexel(cx + x, cy + y, hex);
				HexGeometry.hexelToTringle(hex.x, hex.y, tri);
				// int h = tri.x+tri.y;
				int h = this.bhms.getBlockHeight(tri.x, tri.y, tmp);
				hmap[x][y] = h;
			}
		}

		return hbhm;
	}
}
