package Hexel.generation.terrainGenerator.originalPlateGenerator.heightMap;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import Hexel.Hexel;
import Hexel.math.Vector2i;

public class SHMCFile {
	static {
		File out = new File(getFolder());
		if (!out.exists()) {
			out.mkdirs();
		}
	}

	public static void save(Vector2i p, SmoothHeightMapChunk shmc) {
		String path = getPath(p);
		File file = new File(Hexel.workingDir, path);

		try {
			if (!file.exists() && !file.createNewFile()) {
				System.out.println("Failed to create file!");
			}
			ObjectOutputStream out = new ObjectOutputStream(
					new FileOutputStream(file));
			out.writeObject(shmc);
			out.close();
		} catch (IOException e) {
			System.out.println("Caught Exception saving SHMC");
			e.printStackTrace();
			// System.exit(1);
		}

	}

	public static SmoothHeightMapChunk load(Vector2i p) {

		SmoothHeightMapChunk shmc = null;
		try {
			String path = getPath(p);
			FileInputStream fileIn = new FileInputStream(path);
			ObjectInputStream in = new ObjectInputStream(fileIn);
			shmc = (SmoothHeightMapChunk) in.readObject();
			in.close();
			fileIn.close();
		} catch (IOException e) {
			System.out.println("Caught Exception loading SHMC!");
			e.printStackTrace();
			System.exit(1);
		} catch (ClassNotFoundException e) {
			System.out.println("SHMC class not found");
			e.printStackTrace();
			System.exit(1);
		}
		return shmc;
	}

	public static boolean has(Vector2i p) {
		String path = getPath(p);
		File f = new File(path);
		return f.exists();
	}

	private static String getFolder() {
		return "state/shmcs/";
	}

	private static String getFilename(Vector2i p) {
		return p + ".ser";
	}

	private static String getPath(Vector2i p) {
		return getFolder() + getFilename(p);
	}
}
