package Hexel.generation.terrainGenerator.originalPlateGenerator.plate;

import java.util.Random;

import Hexel.math.Vector2i;

public class Plate {

	public static final int MAX_OFFSET = 30;
	public static final int AVG_OFFSET = 12;
	public static final int AVG_MAGNITUDE = 64;

	public double magnitude;

	public int heightOffset;

	public int heightVariation;

	public int offsetX;
	public int offsetY;

	public double resistanceToChange;

	public Plate(Vector2i p) {
		Random random = new Random(p.hashCode());
		this.offsetX = (int) (random.nextGaussian() * AVG_OFFSET);
		this.offsetY = (int) (random.nextGaussian() * AVG_OFFSET);
		if (Math.abs(this.offsetY) > MAX_OFFSET)
			this.offsetY = (int) (MAX_OFFSET * Math.signum(this.offsetY));
		this.magnitude = random.nextDouble() * AVG_MAGNITUDE;
		this.heightOffset = (int) (this.magnitude + random.nextGaussian() * this.magnitude);

		this.heightVariation = (int) (Math.abs(random.nextGaussian()) * this.magnitude / 4);

		this.resistanceToChange = (int) (random.nextDouble() * this.heightVariation / 2);
	}
}
