package Hexel.things;

import java.util.Hashtable;

import Hexel.blocks.types.Block;
import Hexel.blocks.types.BlockDebug;
import Hexel.blocks.types.BlockGlass;
import Hexel.blocks.types.BlockStone;
import Hexel.blocks.types.BlockWater;
import Hexel.blocks.types.BlockWood;

public class Inventory {

	private Hashtable<Class, Integer> inventory = new Hashtable<Class, Integer>();

	public Inventory() {
		this.inventory.put(BlockDebug.class, 1000000);
		this.inventory.put(BlockWater.class, 1000000);
		this.inventory.put(BlockGlass.class, 1000000);
		this.inventory.put(BlockStone.class, 1000000);
		this.inventory.put(BlockWood.class, 1000000);
	}

	public void addBlock(Block block) {
		Class blockClass = block.getClass();
		int v = 0;
		if (this.inventory.containsKey(blockClass))
			v = this.inventory.get(blockClass);
		this.inventory.put(blockClass, v + 1);
	}

	public boolean hasBlock(Class blockClass) {
		return this.inventory.containsKey(blockClass)
				&& this.inventory.get(blockClass) > 0;
	}

	public boolean useBlock(Class blockClass) {
		if (hasBlock(blockClass)) {
			this.inventory.put(blockClass, this.inventory.get(blockClass) - 1);
			return true;
		} else
			return false;
	}

	public int numBlock(Class blockClass) {
		if (!hasBlock(blockClass))
			return 0;
		return this.inventory.get(blockClass);
	}
}
