package Hexel.things;


public class PaddedCuboid implements Cuboid{
	
	private Cuboid c;
	private double xPadding;
	private double yPadding;
	private double zPadding;
	
	public PaddedCuboid(Cuboid c, double padding){
		this.c = c;
		this.xPadding = padding;
		this.yPadding = padding;
		this.zPadding = padding;
	}
	
	public PaddedCuboid(Cuboid c, double xPadding, double yPadding, double zPadding){
		this.c = c;
		this.xPadding = xPadding;
		this.yPadding = yPadding;
		this.zPadding = zPadding;
	}

	@Override
	public double getX() {
		return c.getX() - xPadding;
	}

	@Override
	public double getY() {
		return c.getY() - yPadding;
	}

	@Override
	public double getZ() {
		return c.getZ() - zPadding;
	}

	@Override
	public double getWidth() {
		return c.getWidth() + 2*xPadding;
	}

	@Override
	public double getHeight() {
		return c.getHeight() + 2*yPadding;
	}

	@Override
	public double getDepth() {
		return c.getDepth() + 2*zPadding;
	}

}
