package Hexel.util;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

public class ResourcePool<T> {
	private BlockingQueue<T> pool;
	private Class<T> klass;

	public ResourcePool(Class<T> klass) {
		this.klass = klass;
		this.pool = new LinkedBlockingQueue<T>();
	}

	public T aquire() {
		try {
			if (this.pool.isEmpty()) {
				T t = this.klass.newInstance();
				this.pool.add(t);
			}
			return this.pool.take();
		} catch (Exception e) {
			System.out.println("fail aquire");
			System.exit(1);
			return null;
		}
	}

	public void recycle(T t) {
		try {
			this.pool.put(t);
		} catch (Exception e) {
			System.out.println("fail recycle");
			System.exit(1);
		}
	}

}
